package com.helix.tasks.model.impl;

import com.helix.tasks.model.Source;
import com.helix.tasks.model.SourceModel;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Source service. Represents a row in the &quot;Helix_Source&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.helix.tasks.model.SourceModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link SourceImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see SourceImpl
 * @see com.helix.tasks.model.Source
 * @see com.helix.tasks.model.SourceModel
 * @generated
 */
public class SourceModelImpl extends BaseModelImpl<Source>
    implements SourceModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a source model instance should use the {@link com.helix.tasks.model.Source} interface instead.
     */
    public static final String TABLE_NAME = "Helix_Source";
    public static final Object[][] TABLE_COLUMNS = {
            { "sourceId", Types.BIGINT },
            { "groupId", Types.BIGINT },
            { "companyId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "createDate", Types.TIMESTAMP },
            { "modifiedDate", Types.TIMESTAMP },
            { "eventSource", Types.VARCHAR },
            { "eventSourceLink", Types.VARCHAR },
            { "imageEsl", Types.VARCHAR },
            { "organizer", Types.VARCHAR },
            { "city", Types.VARCHAR },
            { "country", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Helix_Source (sourceId LONG not null primary key,groupId LONG,companyId LONG,userId LONG,createDate DATE null,modifiedDate DATE null,eventSource VARCHAR(75) null,eventSourceLink TEXT null,imageEsl VARCHAR(75) null,organizer VARCHAR(75) null,city VARCHAR(75) null,country VARCHAR(75) null)";
    public static final String TABLE_SQL_DROP = "drop table Helix_Source";
    public static final String ORDER_BY_JPQL = " ORDER BY source.sourceId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Helix_Source.sourceId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.com.helix.tasks.model.Source"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.com.helix.tasks.model.Source"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.com.helix.tasks.model.Source"),
            true);
    public static long EVENTSOURCELINK_COLUMN_BITMASK = 1L;
    public static long SOURCEID_COLUMN_BITMASK = 2L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.com.helix.tasks.model.Source"));
    private static ClassLoader _classLoader = Source.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] { Source.class };
    private long _sourceId;
    private long _groupId;
    private long _companyId;
    private long _userId;
    private String _userUuid;
    private Date _createDate;
    private Date _modifiedDate;
    private String _eventSource;
    private String _eventSourceLink;
    private String _originalEventSourceLink;
    private String _imageEsl;
    private String _organizer;
    private String _city;
    private String _country;
    private long _columnBitmask;
    private Source _escapedModel;

    public SourceModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _sourceId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setSourceId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _sourceId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Source.class;
    }

    @Override
    public String getModelClassName() {
        return Source.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("sourceId", getSourceId());
        attributes.put("groupId", getGroupId());
        attributes.put("companyId", getCompanyId());
        attributes.put("userId", getUserId());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("eventSource", getEventSource());
        attributes.put("eventSourceLink", getEventSourceLink());
        attributes.put("imageEsl", getImageEsl());
        attributes.put("organizer", getOrganizer());
        attributes.put("city", getCity());
        attributes.put("country", getCountry());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long sourceId = (Long) attributes.get("sourceId");

        if (sourceId != null) {
            setSourceId(sourceId);
        }

        Long groupId = (Long) attributes.get("groupId");

        if (groupId != null) {
            setGroupId(groupId);
        }

        Long companyId = (Long) attributes.get("companyId");

        if (companyId != null) {
            setCompanyId(companyId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String eventSource = (String) attributes.get("eventSource");

        if (eventSource != null) {
            setEventSource(eventSource);
        }

        String eventSourceLink = (String) attributes.get("eventSourceLink");

        if (eventSourceLink != null) {
            setEventSourceLink(eventSourceLink);
        }

        String imageEsl = (String) attributes.get("imageEsl");

        if (imageEsl != null) {
            setImageEsl(imageEsl);
        }

        String organizer = (String) attributes.get("organizer");

        if (organizer != null) {
            setOrganizer(organizer);
        }

        String city = (String) attributes.get("city");

        if (city != null) {
            setCity(city);
        }

        String country = (String) attributes.get("country");

        if (country != null) {
            setCountry(country);
        }
    }

    @Override
    public long getSourceId() {
        return _sourceId;
    }

    @Override
    public void setSourceId(long sourceId) {
        _sourceId = sourceId;
    }

    @Override
    public long getGroupId() {
        return _groupId;
    }

    @Override
    public void setGroupId(long groupId) {
        _groupId = groupId;
    }

    @Override
    public long getCompanyId() {
        return _companyId;
    }

    @Override
    public void setCompanyId(long companyId) {
        _companyId = companyId;
    }

    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public String getEventSource() {
        if (_eventSource == null) {
            return StringPool.BLANK;
        } else {
            return _eventSource;
        }
    }

    @Override
    public void setEventSource(String eventSource) {
        _eventSource = eventSource;
    }

    @Override
    public String getEventSourceLink() {
        if (_eventSourceLink == null) {
            return StringPool.BLANK;
        } else {
            return _eventSourceLink;
        }
    }

    @Override
    public void setEventSourceLink(String eventSourceLink) {
        _columnBitmask |= EVENTSOURCELINK_COLUMN_BITMASK;

        if (_originalEventSourceLink == null) {
            _originalEventSourceLink = _eventSourceLink;
        }

        _eventSourceLink = eventSourceLink;
    }

    public String getOriginalEventSourceLink() {
        return GetterUtil.getString(_originalEventSourceLink);
    }

    @Override
    public String getImageEsl() {
        if (_imageEsl == null) {
            return StringPool.BLANK;
        } else {
            return _imageEsl;
        }
    }

    @Override
    public void setImageEsl(String imageEsl) {
        _imageEsl = imageEsl;
    }

    @Override
    public String getOrganizer() {
        if (_organizer == null) {
            return StringPool.BLANK;
        } else {
            return _organizer;
        }
    }

    @Override
    public void setOrganizer(String organizer) {
        _organizer = organizer;
    }

    @Override
    public String getCity() {
        if (_city == null) {
            return StringPool.BLANK;
        } else {
            return _city;
        }
    }

    @Override
    public void setCity(String city) {
        _city = city;
    }

    @Override
    public String getCountry() {
        if (_country == null) {
            return StringPool.BLANK;
        } else {
            return _country;
        }
    }

    @Override
    public void setCountry(String country) {
        _country = country;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
            Source.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Source toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Source) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        SourceImpl sourceImpl = new SourceImpl();

        sourceImpl.setSourceId(getSourceId());
        sourceImpl.setGroupId(getGroupId());
        sourceImpl.setCompanyId(getCompanyId());
        sourceImpl.setUserId(getUserId());
        sourceImpl.setCreateDate(getCreateDate());
        sourceImpl.setModifiedDate(getModifiedDate());
        sourceImpl.setEventSource(getEventSource());
        sourceImpl.setEventSourceLink(getEventSourceLink());
        sourceImpl.setImageEsl(getImageEsl());
        sourceImpl.setOrganizer(getOrganizer());
        sourceImpl.setCity(getCity());
        sourceImpl.setCountry(getCountry());

        sourceImpl.resetOriginalValues();

        return sourceImpl;
    }

    @Override
    public int compareTo(Source source) {
        long primaryKey = source.getPrimaryKey();

        if (getPrimaryKey() < primaryKey) {
            return -1;
        } else if (getPrimaryKey() > primaryKey) {
            return 1;
        } else {
            return 0;
        }
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Source)) {
            return false;
        }

        Source source = (Source) obj;

        long primaryKey = source.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        SourceModelImpl sourceModelImpl = this;

        sourceModelImpl._originalEventSourceLink = sourceModelImpl._eventSourceLink;

        sourceModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Source> toCacheModel() {
        SourceCacheModel sourceCacheModel = new SourceCacheModel();

        sourceCacheModel.sourceId = getSourceId();

        sourceCacheModel.groupId = getGroupId();

        sourceCacheModel.companyId = getCompanyId();

        sourceCacheModel.userId = getUserId();

        Date createDate = getCreateDate();

        if (createDate != null) {
            sourceCacheModel.createDate = createDate.getTime();
        } else {
            sourceCacheModel.createDate = Long.MIN_VALUE;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            sourceCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            sourceCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        sourceCacheModel.eventSource = getEventSource();

        String eventSource = sourceCacheModel.eventSource;

        if ((eventSource != null) && (eventSource.length() == 0)) {
            sourceCacheModel.eventSource = null;
        }

        sourceCacheModel.eventSourceLink = getEventSourceLink();

        String eventSourceLink = sourceCacheModel.eventSourceLink;

        if ((eventSourceLink != null) && (eventSourceLink.length() == 0)) {
            sourceCacheModel.eventSourceLink = null;
        }

        sourceCacheModel.imageEsl = getImageEsl();

        String imageEsl = sourceCacheModel.imageEsl;

        if ((imageEsl != null) && (imageEsl.length() == 0)) {
            sourceCacheModel.imageEsl = null;
        }

        sourceCacheModel.organizer = getOrganizer();

        String organizer = sourceCacheModel.organizer;

        if ((organizer != null) && (organizer.length() == 0)) {
            sourceCacheModel.organizer = null;
        }

        sourceCacheModel.city = getCity();

        String city = sourceCacheModel.city;

        if ((city != null) && (city.length() == 0)) {
            sourceCacheModel.city = null;
        }

        sourceCacheModel.country = getCountry();

        String country = sourceCacheModel.country;

        if ((country != null) && (country.length() == 0)) {
            sourceCacheModel.country = null;
        }

        return sourceCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(25);

        sb.append("{sourceId=");
        sb.append(getSourceId());
        sb.append(", groupId=");
        sb.append(getGroupId());
        sb.append(", companyId=");
        sb.append(getCompanyId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", eventSource=");
        sb.append(getEventSource());
        sb.append(", eventSourceLink=");
        sb.append(getEventSourceLink());
        sb.append(", imageEsl=");
        sb.append(getImageEsl());
        sb.append(", organizer=");
        sb.append(getOrganizer());
        sb.append(", city=");
        sb.append(getCity());
        sb.append(", country=");
        sb.append(getCountry());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(40);

        sb.append("<model><model-name>");
        sb.append("com.helix.tasks.model.Source");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>sourceId</column-name><column-value><![CDATA[");
        sb.append(getSourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>groupId</column-name><column-value><![CDATA[");
        sb.append(getGroupId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>companyId</column-name><column-value><![CDATA[");
        sb.append(getCompanyId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>eventSource</column-name><column-value><![CDATA[");
        sb.append(getEventSource());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>eventSourceLink</column-name><column-value><![CDATA[");
        sb.append(getEventSourceLink());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>imageEsl</column-name><column-value><![CDATA[");
        sb.append(getImageEsl());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>organizer</column-name><column-value><![CDATA[");
        sb.append(getOrganizer());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>city</column-name><column-value><![CDATA[");
        sb.append(getCity());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>country</column-name><column-value><![CDATA[");
        sb.append(getCountry());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
